/*
 * global_status.h
 *
 *  Created on: 04.01.2015
 *      Author: daniel
 */

#ifndef SRC_GLOBAL_STATUS_H_
#define SRC_GLOBAL_STATUS_H_


#include <stdbool.h>
#include <stdint.h>


//#define INITIALPOWEROFF 10000000L
#define INITIALPOWEROFF 100000L
#define MAXVOLUME 0xff



void globalStatusInit();
void globalStatusIdle();
bool globalStatusIsChangeDir();
void globalStatusResetChangeDir();
void globalStatusSetChangeDir();
void globalStatusPlay();
bool globalStatusIsPause();
void globalStatusResetPause();
void globalStatusSetPause();
bool globalStatusIsSkip();
bool globalStatusIsPlaying();
void globalStatusResetSkip();
void globalStatusSetSkip();
void golbalStatusPlayDir(uint8_t dirnumber);
void globalStatusTogglePause();
void globalStatusSkip();
void globalStatusRewind();
void globalStatusShowActivity();
uint8_t globalStatusGetNextDir();
bool globalStatusSelectNextDir();
uint8_t globalStatusGetCurrentDir();
void globalStatusSystick();
void globalStatusPowerOff();
void globalStatusUpdateVolume();
void globalStatusToggleTone();
void globalStatusStickDetected();

#endif /* SRC_GLOBAL_STATUS_H_ */
